HDU - 5438 (拓扑排序+dfs)

Betty owns a lot of ponds, some of them are connected with other ponds by pipes, and there will not be more than one pipe between two ponds. Each pond has a value vv. 

Now Betty wants to remove some ponds because she does not have enough money. But each time when she removes a pond, she can only remove the ponds which are connected with less than two ponds, or the pond will explode. 

Note that Betty should keep removing ponds until no more ponds can be removed. After that, please help her calculate the sum of the value for each connected component consisting of a odd number of ponds

Input

The first line of input will contain a number T(1≤T≤30)T(1≤T≤30) which is the number of test cases. 

For each test case, the first line contains two number separated by a blank. One is the number p(1≤p≤104)p(1≤p≤104) which represents the number of ponds she owns, and the other is the number m(1≤m≤105)m(1≤m≤105) which represents the number of pipes. 

The next line contains pp numbers v1,...,vpv1,...,vp, where vi(1≤vi≤108)vi(1≤vi≤108) indicating the value of pond ii. 

Each of the last mm lines contain two numbers aa and bb, which indicates that pond aaand pond bb are connected by a pipe.

Output

For each test case, output the sum of the value of all connected components consisting of odd number of ponds after removing all the ponds connected with less than two pipes.

Sample Input

1
7 7
1 2 3 4 5 6 7
1 4
1 5
4 5
2 3
2 6
3 6
2 7

Sample Output

21

 

题目大意:

给出n个点,每个点都有一个价值w,给出m条边,要求先把度数小于2的点删除,然后计算联通块的点为奇数的价值和。

思路:

首先删除点可以用拓扑排序,标记一下。

然后找联同块可以用dfs跑一边。求和。

代码:

#include <cstdio>
#include <iostream>
#include <cstring>
#include <vector>
#include <cmath>
#include <algorithm>
#include <map>
#include <queue>
#include <cmath>
#include <ctime>

using namespace std;
#define ll long long
const int maxn = 2e5+100;
const int maxm = 1e5 + 100;
int n, m;
int in[maxn],vis[maxn];
struct Edge
{
	int to, next;
	Edge() {}
	Edge(int t,int n)
	{
		to = t;
		next = n;
	}
}edges[maxn];
int head[maxn], tot;

void add_edge(int from, int to)
{
	edges[tot] = Edge ( to, head[from] );
	head[from] = tot++;
	in[to]++;
}

bool topo()
{
	queue<int> Q;
	int sum = 0;
	for (int i = 1;i <= n;i++)if (in[i] < 2)
		Q.push(i);

	while (!Q.empty())
	{
		int u = Q.front(); Q.pop();
		vis[u] = 1;
		sum++;
		for (int e = head[u];e != -1;e = edges[e].next)
		{
			int v = edges[e].to;
			if (--in[v] < 2&&!vis[v])
			{
			    Q.push(v);
			}
		}
	}

	return sum;
}
int w[maxn];
void init()
{
	memset(in, 0, sizeof(in));
	memset(w, 0, sizeof(w));
	memset(vis, 0, sizeof(vis));
	memset(head, -1, sizeof(head));
	tot = 0;
}


ll ans;
int dfs(int u, int fa)
{
	ans = ans + w[u];
	int size = 1;
	for (int e = head[u];e != -1;e = edges[e].next)
	{
		int v = edges[e].to;
		if (v == fa)continue;
		if (vis[v])continue;
		vis[v] = 1;
		size+=dfs(v, u);
	}
	return size;
}

int main()
{

	int t;
	scanf("%d", &t);
	while (t--)
	{
		init();
		scanf("%d%d", &n, &m);
		for (int i = 1;i <= n;i++)
		{
			scanf("%d", &w[i]);
		}

		for (int i = 1;i <= m;i++)
		{
			int u, v;
			scanf("%d%d", &u, &v);
			add_edge(u, v);
			add_edge(v, u);
		}
		topo();
		ll sum = 0;
		for (int i = 1;i <= n;i++)
		{
			if (vis[i])continue;
			vis[i] = 1;
			ans = 0;
			int flag=dfs(i, -1);
			if(flag%2==1)
			{
				sum += ans;
			}
		}
		printf("%lld\n", sum);
	}
	return 0;
}

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值